<?php
/*
    StaticPageGenerator.php
    Copyright 2007 MarkS
*/

if (!defined('PmWiki')) exit();

@session_start();

global $ApplicationPathDir;
	
# Create Static Page if they are in the request URL
if ($_REQUEST["createStaticPage"] == "1"){
    $_REQUEST["createStaticPage"] = "0";
    createStaticPage($_REQUEST['n'], $ApplicationPathDir);
    exit;
}

# Delete Static Page if they are in the request URL

if ($_REQUEST["removeStaticPage"] == "1"){
    $_REQUEST["removeStaticPage"] = "0";
    removeStaticPage($_REQUEST['n'], $ApplicationPathDir);
    exit;
}

global $ScriptUrl;
global $StaticPageGeneratorActionName, $StaticPageDir;

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Generate Static Pages</title>
<style type='text/css'><!--

  margin-top:1.33em; margin-bottom:1.33em; }

  table{ border: 2px dotted #ccf; width:90%; }
  td { padding-left:10px; padding-right:10px; }
  td { border-bottom: 1px solid #ccf; }

--></style>
</head>
<body>
<?php
	
?><?php
$outputInformation = '
	<h1>Generate Static Pages </h1>
	<pre>
	
	To perform an operation, select the appropiate page and click the either the Build, Refresh or Remove action.
	
	</pre>';
?> <?php

	$outputActionMenu = "";

	$ACTION = "command";
	$ACTION_REMOVE = "remove";
	$ACTION_REFRESH = "refresh";
	$ACTION_BUILD = "build";
	
	$ACTION_REFRESH_URL = "$ScriptUrl?action=$StaticPageGeneratorActionName&$ACTION=$ACTION_REFRESH";
	
	$outputActionMenu .= "<br /><table frame=\"border\" cellpadding=\"20\" cellspacing=\"0\" >
		    <tr>
		      <td><bold>Actions</bold></td>
		      <td><a class=\"button\" href=\"Javascript:void actionBuildSelectedItems('$ScriptUrl');\" >Build</a></td>
		      <td><a class=\"button\" href=\"$ACTION_REFRESH_URL\" >Refresh</a></td>
		      <td><a class=\"button\" href=\"Javascript:void actionRemoveSelectedItems('$ScriptUrl');\" >Remove</a></td>
		    </tr>  
		  </table><br />";
		  
	# Do actions
	$userAction = $HTTP_GET_VARS[$ACTION];
	
	if ($userAction == $ACTION_REMOVE){

	} elseif ($userAction == $ACTION_REFRESH){
		
	} elseif ($userAction == $ACTION_BUILD){
		
	}
	
?>

<script type="text/javascript">

function openPage(pagename){
	
	var httpRequest = (window.XMLHttpRequest)? new XMLHttpRequest(): new ActiveXObject('Microsoft.XMLHTTP');
	
	httpRequest.open('GET', pagename, false);  // false means synchronysis
    httpRequest.send(null);
}

function toggleAllCheckboxItems(){
	
	var	checkboxParent = document.getElementById("checkboxToggle");
	
	var toggleIds = document.getElementById("wikiLinkList").value.split(",");
	for(i = 0; i < toggleIds.length; i++){
		var current = document.getElementById(toggleIds[i]);
		if (current){
			current.checked = checkboxParent.checked;
		}
	}
}

function doCheckBoxEvents(siteurl, args, checkboxEventIds){

	var	checkboxParent = document.getElementById("checkboxToggle");
	checkboxParent.checked = false;
	
	for(i = 0; i < checkboxEventIds.length; i++){
		var currentItemId = checkboxEventIds[i];
		var currentItem = document.getElementById(currentItemId);
		if (currentItem && currentItem.checked == true){
			openPage(siteurl + '?n=' + currentItemId + '&' + args);
			currentItem.checked = false;
		}
	}
}


function actionBuildSelectedItems(siteurl){
	var toggleIds = document.getElementById("wikiLinkList").value.split(",");
	doCheckBoxEvents(siteurl, "action=<?php echo $StaticPageGeneratorActionName; ?>&createStaticPage=1", toggleIds);
	window.open("<?php echo $ACTION_REFRESH_URL; ?>", "_self");
}

function actionRemoveSelectedItems(siteurl){
	var toggleIds = document.getElementById("wikiLinkList").value.split(",");
	doCheckBoxEvents(siteurl, "action=<?php echo $StaticPageGeneratorActionName; ?>&removeStaticPage=1", toggleIds);
	window.open("<?php echo $ACTION_REFRESH_URL; ?>", "_self");
}

</script>
<?php

$wikiLinkList = ",";
$checkboxToggle = "<input type=\"checkbox\" id=\"checkboxToggle\" onClick=\"Javascript:void toggleAllCheckboxItems();\">";

$outputTable = "";

$outputTable .= "\n\t\t<table border='1'>\n";
$outputTable .= "\t\t\t<tr><th>$checkboxToggle</th><th>File Name</th><th>Timestamp</th><th>Generated</th></tr>\n";

$booleanAreAllPagesGenerated = true;


# Get all wiki page files, and output relevant table
global $WikiLibDirs;
foreach((array)$WikiLibDirs as $dir){
	
	$pageList = $dir->ls();
	$pageArray = (array)$pageList;
	
	$pageArray = array_flip($pageArray);
	ksort($pageArray);
	
	$outputTable .= "\t\t\t<tr><td colspan=\"4\" height=\"50px\" >" . $dir->pagefile("") . "</td></tr>\n";
	
	foreach($pageArray as $aPageName => $index){
		
		$outputTable .= "\t\t\t<tr>";
			
		#See if Generated file exists, the WikiLink and File name are equivilent
		$filePath = $ApplicationPathDir . "/" . $StaticPageDir . "/" . getStaticPageName($aPageName);
		
		$isStaticPage = isPossibleStaticPage($aPageName);
		
		if (file_exists($filePath) && $isStaticPage){
			$outputTable .= "<td align='center'><input type=\"checkbox\" id=\"" . $aPageName . "\"></td>";
	    	$outputTable .= "<td>" . $aPageName . "</td>";
			$outputTable .= "<td>" . date("F d Y H:i:s.", filemtime($filePath)) . "</td>";
			$outputTable .= "<td>Yes</td>";
		} elseif (!file_exists($filePath) && $isStaticPage) {
			$outputTable .= "<td align='center'><input type=\"checkbox\" id=\"" . $aPageName . "\"></td>";
	    	$outputTable .= "<td>" . $aPageName . "</td>";
			$outputTable .= "<td>" . "-" . "</td>";
			$outputTable .= "<td>No</td>";
			$booleanAreAllPagesGenerated = false;
		} elseif (!$isStaticPage){
			@removeStaticPage($targetPageName, $ApplicationPathDir);
			$outputTable .= "<td align='center'></td>";
	    	$outputTable .= "<td>" . $aPageName . "</td>";
			$outputTable .= "<td>" . "-" . "</td>";
			$outputTable .= "<td>-- Excluded --</td>";
		}
		
		$wikiLinkList = $wikiLinkList . $aPageName . "," ;
	    $outputTable .= "</tr>\n";

	}
}

$outputTable .= "\t\t</table>\n";

# output page

echo $outputInformation;
echo "<input type=\"hidden\" id=\"wikiLinkList\" value=\"$wikiLinkList\" />\n";

if ($booleanAreAllPagesGenerated){
	echo "<h2>SUCCESS:  All pages generated.<h2/>\n";
} else {
	echo "<h2>WARNING!!!:  All pages NOT generated.<h2/>\n";		
}

echo $outputActionMenu;

echo $outputTable;

?>
</body></html>

